package com.github.binarywang.demo.wx.cp.controller;

import java.io.IOException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

import com.baomidou.mybatisplus.plugins.Page;
import com.github.binarywang.demo.wx.cp.model.ExternalMobileExcel;
import com.github.binarywang.demo.wx.cp.model.ExternalUser;
import com.github.binarywang.demo.wx.cp.model.ExternalUserExcel;
import com.github.binarywang.demo.wx.cp.service.impl.ExternalMobileService;
import com.github.binarywang.demo.wx.cp.service.impl.ExternalUserService;
import com.github.binarywang.demo.wx.cp.utils.ExcelUtils;
import com.github.binarywang.demo.wx.cp.utils.FiltersData;
import com.github.binarywang.demo.wx.cp.utils.ResultObject;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import com.alibaba.fastjson.JSON;

import javax.servlet.http.HttpServletResponse;

@Controller
@RequestMapping("/api/excel")
public class ExternalUserController {
    @Autowired
    private ExternalUserService externalUserService;
    @Autowired
    private ExternalMobileService externalMobileService;
    private static final Logger log = LogManager.getLogger(ExternalUserController.class);

    //导出模板
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    public void exportExcel(HttpServletResponse response)  throws IOException {
        List<ExternalUserExcel> resultList = new ArrayList<ExternalUserExcel>();
        ExternalUserExcel externalUserExcel = new ExternalUserExcel();
        externalUserExcel.setAge("20");
        externalUserExcel.setGender("男");
        externalUserExcel.setTermainType("多谋");
        externalUserExcel.setUserMobile("13200008888");
        externalUserExcel.setUserName("LLLLLLLLGX");
        SimpleDateFormat sf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss ");
        String startDateStr = sf.format(new Date());
        externalUserExcel.setCreatetime(startDateStr);
        resultList.add(externalUserExcel);
        ExcelUtils.writeExcel(response, resultList, ExternalUserExcel.class,"企业微信客户模板");
    }

    //导入其他数据
    @ResponseBody
    @RequestMapping(value = "/readExcel", method = RequestMethod.POST)
    public void readExcel(HttpServletResponse response,@RequestParam(value="uploadFile", required = false) MultipartFile file) throws ParseException {
        try {
            long t1 = System.currentTimeMillis();
            List<ExternalUserExcel> list = ExcelUtils.readExcel("", ExternalUserExcel.class, file);
            SimpleDateFormat sdf =   new SimpleDateFormat( "yyyy-MM-dd HH:mm:ss");
            //获取登陆信息

            for (ExternalUserExcel userExcel:list){
                int count=externalUserService.getExternalCount(userExcel.getUserMobile());
                if(count>0){
                    userExcel.setRescode("手机号已存在");
                }else{
                    userExcel.setRescode("上传成功");
                    //保存数据
                    ExternalUser externalUser=new ExternalUser();
                    externalUser.setTermainType(userExcel.getTermainType());
                    externalUser.setUserAge(Integer.valueOf(userExcel.getAge()));
                    externalUser.setName(userExcel.getUserName());
                    externalUser.setRemarkMobiles(userExcel.getUserMobile());
                    externalUser.setGender(userExcel.getGender());
                    Date d1=sdf.parse(userExcel.getCreatetime());
                    externalUser.setCreatetime(d1);

                    //导入人
                    externalUser.setCompanyMobiles("13265197787");
                    externalUser.setCompanyName("测试账户");
                    externalUserService.updateExternalUser(externalUser);
                }
                System.out.println(JSON.toJSONString(userExcel));
            }
            long t2 = System.currentTimeMillis();
            System.out.println(String.format("read over! cost:%sms", (t2 - t1)));
            //上传结果导出excel
            ExcelUtils.writeExcel(response, list, ExternalUserExcel.class,"企业微信客户");
        }catch (Exception e){

        }
    }


    //手机号码去重
    @ResponseBody
    @RequestMapping(value = "/readMobileExcel", method = RequestMethod.POST)
    public void readMobileExcel(HttpServletResponse response,@RequestParam(value="uploadFile", required = false) MultipartFile file) throws ParseException {
        try {
            long t1 = System.currentTimeMillis();
            List<ExternalMobileExcel> list = ExcelUtils.readExcel("", ExternalMobileExcel.class, file);
            SimpleDateFormat sdf =   new SimpleDateFormat( "yyyy-MM-dd HH:mm:ss");
            //获取登陆信息

            for (ExternalMobileExcel userExcel:list){
                int count=externalUserService.getExternalCount(userExcel.getUserMobile());
                if(count>0){
                    userExcel.setRescode("该用户已存在");
                }else{
                    userExcel.setRescode("正常");
                }

                System.out.println(JSON.toJSONString(userExcel));
                ExternalMobileExcel externalMobileExcel=new ExternalMobileExcel();
                externalMobileExcel.setAccountId("操作人账户Id");
                externalMobileExcel.setCreatetime(new Date());
                externalMobileExcel.setMobile(userExcel.getUserMobile());
                externalMobileExcel.setRescode(userExcel.getRescode());
                externalMobileService.updateExternalMobile(externalMobileExcel);
            }
            long t2 = System.currentTimeMillis();
            System.out.println(String.format("read over! cost:%sms", (t2 - t1)));
            //上传结果导出excel
            ExcelUtils.writeExcel(response, list, ExternalMobileExcel.class,"企业微信平台手机号");
        }catch (Exception e){

        }

    }

    //手机号去重模板
    @RequestMapping(value = "/exportMobileExcel", method = RequestMethod.GET)
    public void exportMobileExcel(HttpServletResponse response)  throws IOException {
        List<ExternalMobileExcel> resultList = new ArrayList<ExternalMobileExcel>();
        ExternalMobileExcel externalUserExcel = new ExternalMobileExcel();
        externalUserExcel.setUserMobile("13200008888");
        resultList.add(externalUserExcel);
        ExcelUtils.writeExcel(response, resultList, ExternalMobileExcel.class,"企业微信平台手机号模板");
    }

    //获取上传的号码数据
    @ResponseBody
    @RequestMapping(value = "/exportMobileList", method = RequestMethod.GET)
    public ResultObject<List<ExternalMobileExcel>> exportMobileList(@RequestParam(value="accountId") String accountId)  throws IOException {
        List<ExternalMobileExcel> list=new ArrayList<ExternalMobileExcel>();
        if(accountId!=null){
            list=externalMobileService.getExternalMobileList(accountId);
        }
        return ResultObject.success(list);
    }

    //脚本操作成功回调
    @ResponseBody
    @RequestMapping(value = "/editExportMobile", method = RequestMethod.GET)
    public Integer editExportMobile(@RequestParam(value="id") Integer id)  throws IOException {
        Integer count=0;
        if(id!=null){
            ExternalMobileExcel externalMobileExcel=new ExternalMobileExcel();
            externalMobileExcel.setId(id);
            count=externalMobileService.deleteExternalMobile(externalMobileExcel);
        }
        return count;
    }

    @ResponseBody
    @RequestMapping(value = "/getExternalUserList", method = RequestMethod.POST)
    public Map<String,Object> getExternalUserList(@RequestBody FiltersData data){
        return externalUserService.queryExternalList(data);
    }


}
