package com.github.binarywang.demo.wx.cp.model;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.enums.IdType;

import java.io.Serializable;
import java.util.Date;

public class Token extends Model<Token>{
    /**
     * 因为Token只有一个 所有操作都针对这个ID
     */
    public static final Long ID = 1L;

    @TableId(type = IdType.AUTO)
    private Long id;
    @TableField("content")
    private String content;
    @TableField("expire_date")
    private Date expireDate;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    public Date getExpireDate() {
        return expireDate;
    }

    public void setExpireDate(Date expireDate) {
        this.expireDate = expireDate;
    }

    public boolean valid(){
        return this.expireDate != null && this.expireDate.after(new Date());
    }

    public static Token createOne(String content, Date expireDate){
        Token token = new Token();
        token.setId(ID);
        token.setContent(content);
        token.setExpireDate(expireDate);
        return token;
    }

    @Override
    protected Serializable pkVal() {
        return this.id;
    }
}
