package com.github.binarywang.demo.wx.cp.service.impl;

import com.baomidou.mybatisplus.plugins.Page;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import com.github.binarywang.demo.wx.cp.dao.foo.ExternalUserMapper;
import com.github.binarywang.demo.wx.cp.dao.foo.TokenMapper;
import com.github.binarywang.demo.wx.cp.model.ExternalUser;
import com.github.binarywang.demo.wx.cp.model.Token;
import com.github.binarywang.demo.wx.cp.service.IExternalUserService;
import com.github.binarywang.demo.wx.cp.service.ITokenService;
import com.github.binarywang.demo.wx.cp.utils.FiltersData;
import com.github.binarywang.demo.wx.cp.utils.FiltersUtils;
import org.apache.ibatis.annotations.Param;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.atomic.AtomicBoolean;

/**
 * 外部客户管理器
 */
@Service
public class ExternalUserService extends ServiceImpl<ExternalUserMapper, ExternalUser> implements IExternalUserService {


    @Override
    public Integer updateExternalUser(ExternalUser externalUser) {
        return  this.baseMapper.InsertExternalUser(externalUser);
    }

    @Override
    public Integer getExternalCount(String mobile) {
        return this.baseMapper.getExternalUserCount(mobile);
    }

    @Override
    public Map<String,Object> queryExternalList(FiltersData data) {
        Map<String,Object> map=new HashMap<String,Object>();
        int start = (data.getPageIndex()-1) * data.getPageSize();
        int end = (start + 1 + data.getPageSize());
        //动态条件
        String sqlStr=data.getFilterString();
        Integer totalCount=0;
        List<ExternalUser> list = this.baseMapper.queryExternalList(sqlStr,start,end);
        if(list!=null && list.size()>0){
            totalCount=this.baseMapper.queryExternalCount(sqlStr);
            map.put("items",list);
            map.put("totalCount",totalCount);
        }
        return map;
    }
}
